import "color.dart";

class Glyph {
  static final Glyph clear = Glyph(" ", Color.white, Color.black);

  final int charCode;
  final Color fore;
  final Color back;

  Glyph(String char, [Color fore, Color back])
      : charCode = char.codeUnitAt(0),
        this.fore = fore != null ? fore : Color.white,
        this.back = back != null ? back : Color.black;

  Glyph.fromCharCode(int this.charCode, [Color fore, Color back])
      : this.fore = fore != null ? fore : Color.white,
        this.back = back != null ? back : Color.black;

  @override
  bool operator ==(Object other) {
    if (other is Glyph)
      return charCode == other.charCode &&
          fore == other.fore &&
          back == other.back;

    return false;
  }
}
