class KeyInput {
  final int keyCode;
  final bool shift;
  final bool alt;
  final bool ctrl;

  factory KeyInput(int keyCode, {bool shift, bool alt, bool ctrl}) {
    shift ??= false;
    alt ??= false;
    ctrl ??= false;

    return KeyInput._(keyCode, shift, alt, ctrl);
  }

  KeyInput._(this.keyCode, this.shift, this.alt, this.ctrl);

  @override
  bool operator ==(Object o) {
    if (o is KeyInput)
      return keyCode == o.keyCode &&
          shift == o.shift &&
          alt == o.alt &&
          ctrl == o.ctrl;

    return false;
  }

  int get hashCode =>
      keyCode.hashCode ^ shift.hashCode ^ alt.hashCode ^ ctrl.hashCode;

  String toString() {
    String result = "key($keyCode";

    if (shift) result += " shift";
    if (alt) result += " alt";
    if (ctrl) result += " ctrl";

    return result;
  }
}
